   <div>
    <p>Na slici u nastavku prikazan je digitalni sklop s dva ulaza (<i>A</i> i <i>B</i>) i jednim izlazom (<i>f</i>).
       Za razliku od prethodnog "logičkog" pogleda na rad sklopa, ovaj puta je prikazana električka shema izgrađena
       od baterije napona 4,5V, dvije sklopkice, tri otpornika, žaruljice i samog sklopa čiju funkcionalnost ispitujemo.
       Uočite da se na sklop osim ulaza <i>A</i> i <i>B</i> dovodi i napon napajanja (gornja žica) te da je sam sklop
       spojen i na masu (donja žica); bez izvora napajanja i veze prema masi elektronički uređaji ne mogu funkcionirati.
       Tok struje također je animiran - intenzitet je to brži što teće veća struja. Pretpostavit ćemo da promatrani
       sklop ima visok ulazni otpor, što je drugi način za reći da u njegove ulaze struja ne teče. To kod realnih sklopova
       i nije baš sasvim istina ali o tome ćemo brinuti kasnije.
    </p>
    <p>
       Klikom na svaku od sklopkica istu možete uključiti ili isključiti. Kada je sklopka isključena, otpor između njenih krajeva
       je beskonačan i tuda struja ne teče. U toj situaciji, na stezaljkama sklopke potrošit će se čitav napon koji generira
       baterija. Uključena sklopka ima otpor nula (pretpostavit ćemo da je idealna): stoga će u toj situaciju na njoj pad napona 
       biti nula. Kako prema Kirchoffovom zakonu suma svih padova napona u zatvorenoj konturi mora biti nula, i uzimajući u obzir
       da su dvije grane sa sklopkicama spojene paralelno s baterijom, slijedi da u svakoj grani zasebno suma pada napona na sklopki
       i na otporniku mora biti jednaka upravo naponu baterije. Kada je sklopka isključena, sav se napon troši na njoj a kada je
       uključena, sav se napon troši na otporniku.
    </p>
    <p>
       Ulazi sklopa mjere napon na otporniku na koji su spojeni. Dogovorit ćemo se sljedeće: kada je taj napon visok (približno 
       jednak naponu baterije), reći ćemo da je na ulaz dovedena logička vrijednost 1; kada je taj napon nizak (približno 
       jednak 0V), reći ćemo da je na ulaz dovedena logička vrijednost 0. Kako se radi o elektroničkom sklopu, kada je na izlazu
       <i>f</i> logička jedinica, sklop će na taj izlaz dovesti napon baterije: tada se taj izlaz ponaša kao baterija u izlaznom
       strujnom krugu pa će poteći struja kroz žaruljicu i otpornik i žaruljica će prosvijetliti. Kada je na izlazu <i>f</i> logička
       nula, sklop na taj izlaz spaja na masu: nema napona koji bi u izlaznom strujnom krugu potjerao struju i žaruljica će ostati
       ugašena.
    </p>
    <p>Desno od sklopa prikazana je tablica istinitosti kojom želimo opisati ponašanje promatranog digitalnog sklopa.
       Prva dva stupca sadrže vrijednosti ulaza <i>A</i> i <i>B</i>. Za konkretnu kombinaciju ulaza u svakom retku treći
       stupac tablice (stupac označen s <i>f</i>) treba sadržavati vrijednost koju sklop generira na svojem izlazu za
       tu kombinaciju ulaza (kažemo još za takvu <i>pobudu</i>). Vrijednosti u stupcu <i>f</i> možete mijenjati klikom
       miša na odgovarajuću ćeliju.
    </p>
   </div>
   <div class="mlQuestionText">
    <p>Vaš je zadatak da pogledate što sklop generira za različite kombinacije ulaza te na temelju toga popunite 
       stupac <i>f</i> prikazane tablice. Pobudu sklopa možete mijenjati promjenom stanja sklopkica. Kad ste gotovi, 
       pritisnite gumb za nastavak.
    </p>

    <canvas id="myCanvas" width="600" height="340"></canvas>
    <script>
      var canvas = document.getElementById('myCanvas');
      var context = canvas.getContext('2d');
      var state = {
        currentRow: 0,
        vars: 2,
        //elems: [[0,0,0],[0,1,1],[1,0,1],[1,1,0]],
        //userInput: [-1,-1,-1,-1],
        hots: [],
        animOffsets: [0,0,0,0,0,0,0],
        animPattern: [8, 12],
        animLength: 20
      };

      var konfiguracija = @#raw-text#(jsinitdata);
      state.elems = konfiguracija.elems;
      state.userInput = konfiguracija.userInput;
      
      canvas.addEventListener('mousedown', function(evt) {
        var rect = canvas.getBoundingClientRect();
        var pos = {x: evt.clientX - rect.left, y: evt.clientY - rect.top};
        for(var i = 0; i < state.hots.length; i++) {
          var h = state.hots[i];
          if(pos.x>=h.x && pos.x<h.x+h.w && pos.y>=h.y && pos.y<h.y+h.h) {
            h.f(h.state, h.row);
            break;
          }
        }
      }, false);

      function drawFilledCircle(context, x, y) {
        context.fillStyle = '#000000';
        context.strokeStyle = '#000000';
        context.beginPath();
        context.arc(x, y, 3, 0, 2*Math.PI, false);
        context.fill();
      }

      function handler(x,y,w,h,state,row,f) {
        this.x = x; this.y = y; this.w = w; this.h = h; this.state = state; this.row = row; this.f = f;
      }

      function drawBranch(context,state,x,ytop,ybottom,shh1,shh2,shh3,shh4,shh5,sklState,animIndex,animStyle,resistorW) {

        drawAnimated(context, function() {
          if(sklState==1) {
            context.moveTo(x, ytop);
            context.lineTo(x, ytop+shh1+shh2+shh3+shh4+shh5);
          } else {
            context.moveTo(x, ytop);
            context.lineTo(x, ytop+shh1);
            context.moveTo(x, ytop+shh1+shh2);
            context.lineTo(x, ytop+shh1+shh2+shh3+shh4+shh5);
          }
        }, function() {
          context.strokeStyle = '#000000';
          context.setLineDash([]);
        }, sklState==1, function() {
          context.strokeStyle = animStyle;
          context.setLineDash(state.animPattern);
          context.lineDashOffset = -state.animOffsets[animIndex];
        });
        context.setLineDash([]);
        context.beginPath();
        context.fillStyle = "#ffffff";
        context.rect(x-resistorW/2, ytop+shh1+shh2+shh3,resistorW,shh4);
        context.fill();
        context.beginPath();
        context.strokeStyle = "#000000";
        context.rect(x-resistorW/2, ytop+shh1+shh2+shh3,resistorW,shh4);
        context.stroke();

        var angle = 30.0/180.0*3.14;
        if(sklState==0) {
          context.beginPath();
          context.moveTo(x, ytop+shh1+shh2);
          context.lineTo(x+shh2*Math.sin(angle), ytop+shh1+shh2*(1-Math.cos(angle)));
          context.stroke();
        }

        var delta = shh2*Math.sin(angle);
        state.hots.push(new handler(x-delta,ytop+shh1,2*delta,shh2,state,-1,function(state,row){
          var branch = animIndex-5;
          var skl = [state.elems[state.currentRow][0],state.elems[state.currentRow][1]];
          skl[branch] = 1-skl[branch];
          state.currentRow = 2*skl[0]+skl[1];
          draw(canvas, context, state);
        }));

        context.fillStyle = "#ffffff";
        context.strokeStyle = "#000000";

        context.beginPath();
        context.arc(x, ytop+shh1, 3, 0, 2*Math.PI, false);
        context.fill();
        context.stroke();

        context.beginPath();
        context.arc(x, ytop+shh1+shh2, 3, 0, 2*Math.PI, false);
        context.fill();
        context.stroke();

        drawVerticalArrow(context, x+resistorW*1.5, ytop+shh1+shh2+shh3, ytop+shh1+shh2+shh3+shh4, sklState==0 ? "0V" : "4,5V",true);
        drawVerticalArrow(context, x-15, ytop+shh1, ytop+shh1+shh2, sklState==0 ? "4,5V" : "0V",false);
      }

      function drawVerticalArrow(context, x, ytop, ybottom, text, right) {
        context.fillStyle = "#000000";
        context.strokeStyle = "#000000";

        context.beginPath();
        context.moveTo(x, ytop);
        context.lineTo(x, ybottom);
        context.moveTo(x-5, ytop+8);
        context.lineTo(x, ytop);
        context.moveTo(x+5, ytop+8);
        context.lineTo(x, ytop);
        context.stroke();

        context.font = 'normal 12pt Calibri';
        context.textAlign = right ? 'left' : 'right';
        context.textBaseline = 'middle';
        context.fillText(text, right ? x+5 : x-5, (ytop+ybottom)/2);
      }

      function drawAnimated(context,f,prep1,cond,prep2) {
        context.beginPath();
        prep1();
        f();
        context.stroke();
        if(cond) {
          context.beginPath();
          prep2();
          f();
          context.stroke();
        }
      }

      function draw(canvas, context, state) {
        state.hots.length = 0;

        // clear
        context.clearRect(0, 0, canvas.width, canvas.height);

        // Draw shematic...

        var shloff = 40; var shtoff = 20; var shheight = 300; var shw1 = 80; var shw2 = 90; var shw3 = 90; var shw4 = 90;
        var shh1 = 20; var shh2 = 45; var shh4 = 60; var shh5 = shh1; var shh3 = shheight - shh1 - shh2 - shh4 - shh5;
        var sklA = state.elems[state.currentRow][0];
        var sklB = state.elems[state.currentRow][1];
        var circOut = state.elems[state.currentRow][2];
        var resistorW = 16;
        var batteryLong = 30;
        var batteryShort = 20;
        var batteryDist = 8;

        var currs = [1 + circOut + sklA + sklB, 1 + circOut + sklB, 1 + circOut, 1, circOut, sklA, sklB];
        for(var i = 0; i < currs.length; i++) {
          state.animOffsets[i] += currs[i];
          while(state.animOffsets[i] >= state.animLength) state.animOffsets[i] -= state.animLength;
        }

        var animStyle = '#00ff00';

        drawAnimated(context, function() {
          context.moveTo(shloff+shw1, shtoff + shheight);
          context.lineTo(shloff, shtoff + shheight);
          context.lineTo(shloff, shtoff);
          context.lineTo(shloff+shw1, shtoff);
        }, function() {
          context.strokeStyle = '#000000';
          context.setLineDash([]);
        }, 1==1, function() {
          context.strokeStyle = animStyle;
          context.setLineDash(state.animPattern);
          context.lineDashOffset = -state.animOffsets[0];
        });

        drawFilledCircle(context, shloff+shw1, shtoff + shheight);
        drawFilledCircle(context, shloff+shw1, shtoff);

        drawAnimated(context, function() {
          context.moveTo(shloff+shw1, shtoff);
          context.lineTo(shloff+shw1+shw2, shtoff);
          context.moveTo(shloff+shw1+shw2, shtoff + shheight);
          context.lineTo(shloff+shw1, shtoff + shheight);
        }, function() {
          context.strokeStyle = '#000000';
          context.setLineDash([]);
        }, 1==1, function() {
          context.strokeStyle = animStyle;
          context.setLineDash(state.animPattern);
          context.lineDashOffset = -state.animOffsets[1];
        });
        drawFilledCircle(context, shloff+shw1+shw2, shtoff);
        drawFilledCircle(context, shloff+shw1+shw2, shtoff+shheight);

        drawAnimated(context, function() {
          context.moveTo(shloff+shw1+shw2, shtoff);
          context.lineTo(shloff+shw1+shw2+shw3, shtoff);
          context.lineTo(shloff+shw1+shw2+shw3, shtoff+shheight/2);
          context.moveTo(shloff+shw1+shw2+shw3, shtoff+shheight);
          context.lineTo(shloff+shw1+shw2, shtoff+shheight);
        }, function() {
          context.strokeStyle = '#000000';
          context.setLineDash([]);
        }, 1==1, function() {
          context.strokeStyle = animStyle;
          context.setLineDash(state.animPattern);
          context.lineDashOffset = -state.animOffsets[2];
        });
        drawFilledCircle(context, shloff+shw1+shw2+shw3, shtoff+shheight);

        drawAnimated(context, function() {
          context.moveTo(shloff+shw1+shw2+shw3, shtoff+shheight/2);
          context.lineTo(shloff+shw1+shw2+shw3, shtoff+shheight);
        }, function() {
          context.strokeStyle = '#000000';
          context.setLineDash([]);
        }, 1==1, function() {
          context.strokeStyle = animStyle;
          context.setLineDash(state.animPattern);
          context.lineDashOffset = -state.animOffsets[3];
        });

        drawAnimated(context, function() {
          context.moveTo(shloff+shw1+shw2+shw3, shtoff+shheight/2);
          context.lineTo(shloff+shw1+shw2+shw3+shw4, shtoff+shheight/2);
          context.lineTo(shloff+shw1+shw2+shw3+shw4, shtoff+shheight);
          context.lineTo(shloff+shw1+shw2+shw3, shtoff+shheight);
        }, function() {
          context.strokeStyle = '#000000';
          context.setLineDash([]);
        }, circOut==1, function() {
          context.strokeStyle = animStyle;
          context.setLineDash(state.animPattern);
          context.lineDashOffset = -state.animOffsets[4];
        });
        drawBranch(context,state,shloff+shw1,shtoff,shtoff+shheight,shh1,shh2,shh3,shh4,shh5,sklA,5,animStyle,resistorW);
        drawBranch(context,state,shloff+shw1+shw2,shtoff,shtoff+shheight,shh1,shh2,shh3,shh4,shh5,sklB,6,animStyle,resistorW);

        context.setLineDash([]);
        context.lineDashOffset = 0;

        context.setLineDash([]);
        context.beginPath();
        context.fillStyle = "#ffffff";
        context.rect(shloff+shw1+shw2+shw3+shw4-resistorW/2, shtoff+shh1+shh2+shh3,resistorW,shh4);
        context.fill();
        context.beginPath();
        context.strokeStyle = "#000000";
        context.rect(shloff+shw1+shw2+shw3+shw4-resistorW/2, shtoff+shh1+shh2+shh3,resistorW,shh4);
        context.stroke();

        var x1 = shloff+shw1+shw2+shw3+shw4;
        var y1 = (shtoff+shheight/2 + shtoff+shh1+shh2+shh3) / 2;
        var r1 = 18;
        var d1 = r1*Math.sqrt(2)/2;
        context.fillStyle = circOut==1 ? "#ffff00" : "#cccccc";
        context.strokeStyle = "#000000";
        context.beginPath();
        context.arc(x1,y1,r1,0,2*Math.PI,false);
        context.fill();
        context.beginPath();
        context.arc(x1,y1,r1,0,2*Math.PI,false);
        context.stroke();
        context.beginPath();
        context.moveTo(x1-d1,y1-d1);
        context.lineTo(x1+d1,y1+d1);
        context.moveTo(x1+d1,y1-d1);
        context.lineTo(x1-d1,y1+d1);
        context.stroke();

        drawVerticalArrow(context, x1+r1+12, y1-r1, shtoff+shh1+shh2+shh3+shh4, circOut==0 ? "0V" : "4,5V",true);

        context.strokeStyle = "#000000";
        context.fillStyle = "#ffffff";
        context.beginPath();
        context.rect(shloff-batteryLong/2, shtoff+shheight/2-batteryDist/2, batteryLong, batteryDist);
        context.fill();
        context.beginPath();
        context.moveTo(shloff-batteryLong/2, shtoff+shheight/2-batteryDist/2);
        context.lineTo(shloff+batteryLong/2, shtoff+shheight/2-batteryDist/2);
        context.moveTo(shloff-batteryShort/2, shtoff+shheight/2+batteryDist/2);
        context.lineTo(shloff+batteryShort/2, shtoff+shheight/2+batteryDist/2);
        context.stroke();

        context.font = 'normal 12pt Calibri';
        context.textAlign = 'left';
        context.textBaseline = 'middle';
        context.fillStyle = "#000000";
        context.fillText('4,5V', shloff+batteryLong/2+5, shtoff+shheight/2);

        // Draw circuit...

        var cvertOut = 20; var cvertBetween = 50; var choriz = 70; var connector = 10;
        var cheight = 2*cvertOut + (state.vars-1)*cvertBetween;
        var cloff = shloff+shw1+shw2+shw3-connector-choriz/2; var ctoff = shtoff + (shheight-cheight)/2;

        context.fillStyle = '#000000';
        context.strokeStyle = '#000000';
        context.beginPath();
        for(var v = 0; v < state.vars; v++) {
          context.moveTo(shloff+shw1+v*shw2, ctoff+cvertOut+v*cvertBetween);
          context.lineTo(cloff + connector, ctoff+cvertOut+v*cvertBetween);
        }
        context.stroke();

        for(var v = 0; v < state.vars; v++) {
          drawFilledCircle(context, shloff+shw1+v*shw2, ctoff+cvertOut+v*cvertBetween);
        }

        context.beginPath();
        context.fillStyle = '#000000';
        context.rect(cloff + connector, ctoff, choriz, cheight);
        context.fill();


        var cfontSize = 14;
        context.font = 'normal '+cfontSize+'pt Calibri';

        context.beginPath();
        for(var v = 0; v < state.vars; v++) {
          context.strokeStyle = '#ffffff';
          context.textAlign = 'left';
          context.textBaseline = 'middle';
          context.strokeText(String.fromCharCode(65+v), cloff + connector + 2, ctoff+cvertOut+v*cvertBetween);
          context.strokeStyle = '#000000';
          context.textAlign = 'right';
          context.textBaseline = 'bottom';
          context.strokeText(''+state.elems[state.currentRow][v], cloff - 2, ctoff+cvertOut+v*cvertBetween);
        }
        context.strokeStyle = '#ffffff';
        context.textAlign = 'right';
        context.textBaseline = 'middle';
        context.strokeText('f', cloff + connector + choriz - 2, ctoff+cheight/2);
        context.strokeStyle = '#000000';
        context.textAlign = 'left';
        context.textBaseline = 'bottom';
        context.strokeText(''+state.elems[state.currentRow][state.vars], cloff + connector + choriz + connector + 2, ctoff+cheight/2);

        // Draw table...

        var rh = 30; var toff = 10; var loff = 440; var cw = 50;

        context.beginPath();
        context.strokeStyle = '#000000';
        context.rect(0, 0, canvas.width, canvas.height);
        context.stroke();

        context.beginPath();
        context.rect(loff, toff, state.elems[0].length*cw, rh);
        context.fillStyle = '#cccccc';
        context.fill();

        context.beginPath();
        context.rect(loff, toff+(state.currentRow+1)*rh, state.elems[0].length*cw, rh);
        context.fillStyle = 'yellow';
        context.fill();

        context.beginPath();
        context.lineWidth = 1;
        for(var y = 0; y <= state.elems.length+1; y++) {
          context.moveTo(loff, y*rh+toff);
          context.lineTo(loff+state.elems[0].length*cw, y*rh+toff);
        }
        for(var x = 0; x <= state.elems[0].length; x++) {
          context.moveTo(loff+x*cw, toff);
          context.lineTo(loff+x*cw, (state.elems.length+1)*rh+toff);
        }
        context.strokeStyle = '#ff0000';
        context.stroke();

        var fontSize = 14;
        context.font = 'normal '+fontSize+'pt Calibri';
        context.textAlign = 'center';
        context.textBaseline = 'bottom';

        for(var y = 0; y < state.elems.length+1; y++) {
          for(var x = 0; x < state.elems[0].length; x++) {
            var txt = y==0 ? (x<state.elems[0].length-1 ? String.fromCharCode(65+x) : 'f') : ''+state.elems[y-1][x];
            if(y>0 && x==state.elems[0].length-1) {
              txt = state.userInput[y-1];
              if(txt==-1) txt = "?";
              state.hots.push(new handler(loff+x*cw,y*rh+toff,cw,rh,state,y-1,function(state,row){
                var u = state.userInput[row];
                if(u==-1) { u = 0; } else { u = 1-u; }
                state.userInput[row] = u;
                draw(canvas, context, state);
              }));
            }
            context.strokeText(txt, loff+(x+0.5)*cw, (y+1)*rh+toff-(rh-fontSize)/4);
          }
        }

      }

      function animate(canvas, context, state) {
        draw(canvas, context, state);
        window.setTimeout(function() {
          animate(canvas, context, state);
        }, 40);
      }

      draw(canvas, context, state);
      window.setTimeout(function() {
        animate(canvas, context, state);
      }, 40);

      function questionCollectUserData() {
        return {userInput: [state.userInput[0], state.userInput[1], state.userInput[2], state.userInput[3]]};
      }
    </script>
   </div>
